<template>
    <div class="home">
        <section class="ab-info-main py-md-5 py-4 editContent">
            <div class="container-fluid py-md-3">
                <div class="row">
                    <div class="side-bar col-lg-3">
                          <div class="form-inline my-2 my-lg-0">
                                <input class="form-control mr-sm-2" type="text" placeholder="Search by name" v-model="search_term" aria-label="Search">
                              <button class="btn btn-outline-success my-2 my-sm-0" v-on:click.prevent="getRestaurants()">Search</button>
                          </div>
                        <div class="customer-rev left-side my-4">
                            <h3 class="sear-head editContent">Stars filter</h3>
                            <ul class="w3layouts-box-list">
                                <li>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="editContent" v-on:click.prevent="getRestaurantStars(5)">5.0</span>
                                </li>
                                <li>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star-o" aria-hidden="true"></span>
                                    <span class="editContent" v-on:click.prevent="getRestaurantStars(4)">4.0</span>
                                </li>
                                <li>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star-half-o" aria-hidden="true"></span>
                                    <span class="fa fa-star-o" aria-hidden="true"></span>
                                    <span class="editContent" v-on:click.prevent="getRestaurantStars(3.5)">3.5</span>
                                </li>
                                <li>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star-o" aria-hidden="true"></span>
                                    <span class="fa fa-star-o" aria-hidden="true"></span>
                                    <span class="editContent" v-on:click.prevent="getRestaurantStars(3)">3.0</span>
                                </li>
                                <li>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star" aria-hidden="true"></span>
                                    <span class="fa fa-star-half-o" aria-hidden="true"></span>
                                    <span class="fa fa-star-o" aria-hidden="true"></span>
                                    <span class="fa fa-star-o" aria-hidden="true"></span>
                                    <span class="editContent" v-on:click.prevent="getRestaurantStars(0)">2.5</span>
                                </li>
                            </ul>
                        </div>
                    </div>
                    <div class="left-ads-display col-lg-9">
                        <div class="row">
                            <div v-for="restaurant in listRestaurant" :key="restaurant.id" class="col-md-4 product-men">
                                <div class="product-shoe-info editContent text-center mt-lg-4">
                                    <div class="men-thumb-item">
                                        <img :src="restaurant.photo" class="img-fluid" alt="">
                                    </div>
                                    <div class="item-info-product">
                                        <h4 class="">
                                            <a href="#" @click="goTo(restaurant.id)" class="editContent">{{ restaurant.name }}</a>
                                        </h4>
                                        <ul class="stars">
                                            <li v-for="star in listStar" :key="star">
                                                <a href="#">
                                                    <span class="fa":class="star <= restaurant.middle_star ? 'fa-star' : 'fa-star-o' "aria-hidden="true"></span>
                                                </a>
                                            </li>
                                        </ul>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <Pagination :total="total" :item="listRestaurant.length" @page-changed="loadListRestaurants"/>
                    </div>
                </div>
            </div>
        </section>
    </div>
</template>

<script>
    import Pagination from "../components/Pagination";
    export default {
        name: 'Home',
        data() {
            return {
                listRestaurant: [],
                listStar: [1, 2, 3, 4, 5],
                page: 1,
                total: 0,
                search_term: ''
            }
        },
        components: {Pagination},
        created() {
            this.loadListRestaurants(this.page)
        },
        methods: {
            async loadListRestaurants(pageNumber) {
                this.listRestaurant = await fetch(
                    `${this.$store.getters.getServerUrl}?page=${pageNumber}`
                ).then(response => response.json()
                ).then(response => {
                    this.total = response.count
                    if (response.next==null){
                        this.total = 1
                    }
                    return response.results
                })
            },
            goTo(id) {
                this.$router.push({ name: 'Single', params: {id: id} })
            },
            async getRestaurants() {
                if(this.search_term!==''||this.search_term!==null) {
                    this.listRestaurant = await fetch(
                        `${this.$store.getters.getServerUrl}?name=${this.search_term}`
                    ).then(response => response.json()
                    ).then(response => {
                        this.total = response.count
                        if (response.next==null){
                            this.total = 1
                        }
                        return response.results
                    })
                }
            },
            async getRestaurantStars(star) {
                this.listRestaurant = await fetch(
                    `${this.$store.getters.getServerUrl}?stars=${star}`
                ).then(response => response.json()
                ).then(response => {
                    this.total = response.count
                    if (response.next==null){
                        this.total = 1
                    }
                    return response.results
                })
            },
        }
    }
</script>

<style scoped>
    .editContent {
        padding-left: 3rem;
        padding-right: 3rem;
    }
</style>
